#include "Status.h"
#include "Vram.h"
#include "Print.h"
#include "Chars.h"
#include "Sprite.h"
#include "VVram.h"
#include "Main.h"
#include "Rader.h"

constexpr byte Char_Remain = Char_Fighter;

static ptr<byte> PrintS(ptr<byte> pVram, ptr<byte> p)
{
    byte c;
    while ((c = *p) != 0) {
        pVram = PrintC(pVram, c);
        ++p;
    }
    return pVram;
}

void PrintStatus()
{
    // PrintS(Vram + VramRowSize * 0 + VVramWidth * VramStep, "SCORE");
    // PrintS(Vram + VramRowSize * 3 + VVramWidth * VramStep, "HIGH");
    // PrintS(Vram + VramRowSize * 4 + VVramWidth * VramStep, "SCORE");
    // PrintS(Vram + VramRowSize * 3 + VVramWidth * VramStep, "STAGE");
    PrintByteNumber2(Vram + VramRowSize * 1 + (VVramWidth + 4) * VramStep, CurrentStage + 1);
    PrintScore();
    PrintRemain();
    PrintRader();
}

void PrintScore()
{
    ptr<byte> pVram;
    
    pVram = PrintNumber5(Vram + VramRowSize * 0 + VVramWidth * VramStep, Score);
    PrintC(pVram, '0');

    // pVram = PrintNumber5(Vram + VramRowSize * 5 + VVramWidth * VramStep, HiScore);
    // PrintC(pVram, '0');
}

void PrintRemain()
{
    ptr<byte> pVram;
    pVram = Vram + VramRowSize * 3 + (VVramWidth + 1) * VramStep;
    if (RemainCount > 1) {
        byte i;
        i = RemainCount - 1;
        if (i > 2) {
            pVram = Put2C(pVram, Char_Remain);
            pVram = Erase2(pVram);
            pVram += VramRowSize - 2;
            pVram = PrintC(pVram, i + 0x30);
            pVram += 1 - VramRowSize;
        }
        else {
            do {
                pVram = Put2C(pVram, Char_Remain);
                --i;
            } while (i > 0);
        }
    }
    if (RemainCount < 3) {
        pVram = Erase2(pVram);
    }
}


void PrintGameOver()
{
    constexpr byte Left = (VVramWidth - 8) / 2;
    PrintS(Vram + VramRowSize * (VramHeight / 4) + Left * VramStep, "GAME OVER");
    PresendVram();
}

void Title()
{
    ClearScreen(); 
    HideAllSprites();
    // UpdateSprites();
    PrintStatus();
    {
        static const byte[] TitleBytes = {
            0x0f, 0x0d, 0x02, 0x0f, 
            0x0f, 0x0e, 0x01, 0x0f, 
            0x0f, 0x0c, 0x03, 0x0f, 
            0x05, 0x04, 0x01, 0x04, 
            0x0c, 0x03, 0x0f, 0x0d, 
            0x0c, 0x03, 0x0f, 0x0e, 
            0x0c, 0x03, 0x0f, 0x05, 
            0x05, 0x00, 0x05, 0x00, 
            0x02, 0x0d, 0x07, 0x0c, 
            0x03, 0x0c, 0x03, 0x0c, 
            0x00, 0x0c, 0x03, 0x0c, 
            0x00, 0x04, 0x01, 0x00, 
            0x03, 0x0f, 0x08, 0x07, 
            0x03, 0x0f, 0x04, 0x0b, 
            0x03, 0x0f, 0x08, 0x02, 
            0x05, 0x01, 0x00, 0x05, 
            0x0b, 0x00, 0x00, 0x00, 
            0x02, 0x00, 0x00, 0x00, 
            0x0f, 0x00, 0x00, 0x00, 
            0x01, 0x00, 0x00, 0x00, 
        };
        constexpr byte LogoLength = 5;
        ptr<byte> p;
        ptr<byte> pVram;
        pVram = Vram + VramRowSize * 1;
        p = TitleBytes;
        repeat (LogoLength) {
            repeat (2) {
                repeat (4) {
                    pVram = PutU(pVram, *p);
                    ++p;
                }
                pVram -= 4 * VramStep;
                repeat (4) {
                    pVram = PutL(pVram, *p);
                    ++p;
                }
                pVram += VramRowSize - 4 * VramStep;
            }
            pVram += 4 * VramStep - VramRowSize * 2;
        }
        PrintS(Vram + VramRowSize * 3 + (VVramWidth - 6) * VramStep, "MINI");
    }
    PrintS(Vram + VramRowSize * 5 + (VVramWidth - 14) * VramStep / 2, "PUSH SPACE KEY");
    PrintS(Vram + VramRowSize * 6 + (VVramWidth - 14) * VramStep / 2, "OR RETURN KEY");
    PrintS(Vram + VramRowSize * 7 + (VVramWidth - 12) * VramStep, "INUFUTO 2023");
    // {
    //     byte c;
    //     ptr<byte> pVram;
    //     pVram = Vram;
    //     c = 0;
    //     repeat (0) {
    //         pVram = Put(pVram, c);
    //         ++c;
    //         if ((c & 15) == 0) {
    //             pVram += VramRowSize - 16;
    //         }
    //     }
    // //     // UpdateEnemyChars();
    // //     // SwitchChars();
    // //     // while (true) {
    // //     //     ++EnemyRowLeft;
    // //     //     UpdateEnemyChars();
    // //     //     SwitchChars();
    // //     //     WaitTimer(30);
    // //     // }
    // }
    PresendVram();
}
